﻿using Syncfusion.XForms.DataForm;
using Syncfusion.XForms.DataForm.Editors;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using Xamarin.Forms.Internals;
using System.Reflection;
using System.Diagnostics;


namespace DataFormTest
{
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
            var expenseInfo = new ContactInfo();
            // CustomEditor Registration
           // dataForm.RegisterEditor("Imageditor", new ImageEditor(this.dataForm));

            dataForm.RegisterEditor("CustomEditors", new CustomEditor(dataForm));
            dataForm.RegisterEditor("Name", "CustomEditors");

            //dataForm.RegisterEditor("LastName","Imageditor" );
            dataForm.DataObject = expenseInfo;            
            
        }

        internal static FieldInfo GetField(Type type, string fieldName)
        {
            return type.GetField(fieldName);
        }

        public async void OnSigninButtonClicked(object sender, EventArgs args)
        {
            // myDataObject.Name is an empty string; 
            // myDataObject.LastName is updated as I am expecting.
            var myDataObject = dataForm.DataObject;
        }



    }
    public class CustomEditor : DataFormEditor<MyEntry>
    {
        public CustomEditor(SfDataForm dataForm) : base(dataForm)
        {

        }

        protected override void OnInitializeView(DataFormItem dataFormItem, MyEntry view)
        {
            view.Text = "Items";
        }
        protected override MyEntry OnCreateEditorView()
        {
            return new MyEntry();
        }
   }  

    public class ImageEditor : DataFormEditor<ContentView>
    {

        TapGestureRecognizer tapGestureRecognizer;


        public ImageEditor(SfDataForm dataForm):base(dataForm)
        {
            tapGestureRecognizer = new TapGestureRecognizer();
        }

        protected override ContentView OnCreateEditorView()
		{
            
            return new ContentView();

		}
        protected override void OnInitializeView(DataFormItem dataFormItem, ContentView view)
		{
            Image image = new Image();
            image.InputTransparent = true;

            image.Source = ImageSource.FromFile("Default.png");

            image.IsEnabled = true;

            view.GestureRecognizers.Add(tapGestureRecognizer);
            base.OnInitializeView(dataFormItem, view);
            view.Content = (image);


          


		}
        protected override void OnWireEvents(ContentView view)
		{
            tapGestureRecognizer.Tapped += ImageTapped;
		}
        protected override void OnUnWireEvents(ContentView view)
		{
            tapGestureRecognizer.Tapped -= ImageTapped;
		}
        protected override void OnCommitValue(ContentView view)
		{
            base.OnCommitValue(view);
		}
        private void ImageTapped(object sender, EventArgs e)
        {
            
        }
	}
}

